routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

 // Route::get('/','HomeController@home');
  Route::get('/',function(){
 	 return view('hasen');
  });

Route::match(['get','post'],'/LogIn','LoginController@LoginControl')->name('Login')->middleware('throttle:3,1');
Route::get('home','HomeController@home')->name('Home');

/* Routes Accessible By Registerar */

Route::prefix('Registerars')->name('Registerar.')->middleware('Registerar')->group(function(){

	Route::get('{id}/LogOut','Registerar\LogOutController@LOgOut')->name('LogOut');
	Route::get('{id}/Profile','Registerar\ProfileController@ShowProfile')->name('Profile');
	Route::get('/Add_Patient','Registerar\PatientController@Add')->name('Add_Patient');
	Route::get('{id}/Search_Patient','Registerar\PatientController@Search_Patient')->name('Search_Patient');
	Route::get('{id1}/Send_Patient/{id2}','Registerar\PatientController@Send_Patient')->name('Send_Patient');
	Route::get('{id}/ChangeProfile','Common\ChangeProfileController@Index')->name('ChangeProfile');
	Route::post('{id}/UpdateProfile','Common\ChangeProfileController@UpdateProfile')->name('UpdateProfile');
	Route::get('{id}/UpdateImage','Common\ChangeProfileController@Show_Update_plate')->name('UpdateImage');
	Route::post('{id}/ImageUpdated','Common\ChangeProfileController@ImageUpdated')->name('ImageUpdated');
	Route::get('{id}/Show_Password_Template','Common\ChangeProfileController@Show_Password_Template')->name('Show_Password_Template');
	Route::post('{id}/ChangePassword','Common\ChangeProfileController@ChangePassword')->name('ChangePassword');
	
});

/* Routes Accessible By Doctors */
Route::prefix('Doctors')->name('Doctors.')->middleware('Doctors')->group(function(){
	Route::get('{id}/LogOut','Doctors\LogOutController@LogOut')->name('LogOut');

	Route::get('{id}/Profile','Doctors\ProfileController@ShowProfile')->name('Profile');

	Route::get('/SelectRoom','Common\RoomController@SelectRoom')->name('SelectRoom');

	Route::get('/Show_Patient_List','Doctors\PatientTaskController@Show_Patient_List')->name('Show_Patient_List');

	Route::get('{id1}/View_Patient_Data/{id2}','Doctors\PatientTaskController@View_Patient_Data')->name('View_Patient_Data');
	Route::get('{username}/Add_Patient_result/{clinic_id}','Doctors\PatientTaskController@Add_Patient_result')->name('Add_Patient_result');
	Route::post('{username}/Submit_Result/{clinic_id}','Doctors\PatientTaskController@Submit_Result')->name('Submit_Result');

	Route::get('{username}/Send_To_Phermacy/{clinic_id}','Doctors\PatientTaskController@Send_To_Phermacy')->name('Send_To_Phermacy');
	Route::get('Show_Medicine_Paper/{clinic_id}','Doctors\PatientTaskController@Show_Medicine_Paper')->name('Show_Medicine_Paper');
	Route::get('Labratory_Paper/{clinic_id}','Doctors\PatientTaskController@Labratory_Paper')->name('Labratory_Paper');
	Route::get('{doctor_id}/Send_To_Labratory/{clinic_id}','Doctors\PatientTaskController@Send_To_Labratory')->name('Send_To_Labratory');
	Route::get('Finish_Result/{clinic_id}','Doctors\PatientTaskController@Finish_Result')->name('Finish_Result');
	




});

/* Route Accessible By Phermacy */

Route::prefix('Phermacy')->name('Phermacy.')->middleware('Phermacy')->group(function(){
	Route::get('{id}/LogOut','Phermacy\LogOutController@LogOut')->name('LogOut');
	Route::get('{id}/Profile','Phermacy\ProfileController@ShowProfile')->name('Profile');
	Route::get('/SelectRoom','Common\RoomController@SelectRoom')->name('SelectRoom');
	Route::get('Show_Patient_List','Phermacy\PatientTaskController@Show_Patient_List')->name('Show_Patient_List');
	Route::get('/Show_Medical_Instruction/{clinic_id}','Phermacy\PatientTaskController@Show_Medical_Instruction')->name('Show_Medical_Instruction');
	Route::get('Finish_Patient/{clinic_id}','Phermacy\PatientTaskController@Finish_Patient')->name('Finish_Patient');

});

/* Route Accessible By Laboatorist */
Route::prefix('Labratory')->name('Labratory.')->middleware('Labratory')->group(function(){
	Route::get('{id}/LogOut','Labratory\LogOutController@LogOut')->name('LogOut');
	Route::get('{id}/Profile','Labratory\ProfileController@ShowProfile')->name('Profile');
	Route::get('/SelectRoom','Common\RoomController@SelectRoom')->name('SelectRoom');
	Route::get('/Show_Patient_List','Labratory\PatientTaskController@Show_Patient_List')->name('Show_Patient_List');
	Route::get('{username}/Show_Patient_Data/{clinic_id}','Labratory\PatientTaskController@Show_Patient_Data')->name('Show_Patient_Data');
	Route::get('{username}/Finish/{clinic_id}','Labratory\PatientTaskController@Finish')->name('Finish');
	Route::get('{username}/Add_Patient_Result/{clinic_id}','Labratory\PatientTaskController@Add_Patient_Result')->name('Add_Patient_Result');
	Route::get('/{username}/Submit_Result/{clinic_id}','Labratory\PatientTaskController@Submit_Result')->name('Submit_Result');

});

app/Registerar.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\Registerar as Authenticatable;

class registerar extends Authenticatable
{
    public $table='registerar';
    protected $guarded=['email','password','username'];

    protected $hidden=[
    'password','remember_token','username'
    ];

    public $primaryKey="username";
    public $incrementing=false;
    public $keyType='char';

}

app/Http/Controllers/Registerar/LogOutController.php
<?php

namespace App\Http\Controllers\Registerar;
use Illuminate\Support\Facades\Auth;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class LogOutController extends Controller
{
    

    public function LogOut(){
    	Auth::guard('Registerar')->logout();
    	return redirect('/')->with('Success','Sign Out Successfully');
    }

}

app/Http/Controllers/Registerar/PatientController.php
<?php

namespace App\Http\Controllers\Registerar;
use App\Http\Controllers\Clinic\AdditionalController;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Storage;
use Illuminate\Http\File;
use App\Patient\AddPatient;
use App\Patient\SendPatient;
use App\Admin\AddRoom;
use Illuminate\Support\Carbon;

class PatientController extends Controller
{
    public function Add(request $request){
       $request->validate([
         'first_name'=>'required|string',
         'last_name'=>'required|string',
         'age'=>'required|integer',
         'sex'=>'required',
    	]);



       $id_extension=AddPatient::all()->count();
       $clinic_id='ASC_'.$id_extension.'_'.now()->year;
       
       $Patient=AddPatient::create([
       	'clinic_id'=>$clinic_id,
       	'last_name'=>$request['last_name'],
       	'first_name'=>$request['first_name'],
       	'age'=>$request['age'],
       	'sex'=>$request['sex'],
       	'grand_name'=>$request['grand_name'],
       	'photo_path'=>'/storage/profilepicture.jpg']
       );
       
       $request->Session()->flash('message_success',$Patient->first_name.' Added Successfully');
    
       if($Patient){

       	         return view('Registerar.Home')->with('Patient',$Patient);
       	}


       else
       {
       	return redirect()->route('Home')->with('message_warning','there is file or database error');
       }

    }

    public function Search_Patient(request $request){
    	$request->validate(['search'=>'required|string']);
    	$search=$request['search'];
    	if($Patient=AddPatient::find($search)){
    		return view('Registerar.Home',['Patient'=>$Patient]);
    	}

    	else{
    		return redirect()->route('Home')->with('message_warning','Patient Not Found');
    	}
    }

    /*send patient to docors room */

    public function Send_Patient($id1,$id2){
      $check=SendPatient::where('patient_id',$id2)->whereDate('created_at',Carbon::today())->whereNull('mark')->count();
      if(($check>0)){
        return redirect()->route('Home')->with('message_warning','Resending to patient_room is Aborted');
      }

      $age=AddPatient::find($id2)->age;
      $room_value;
      if($age<15){
      	$room_value=AdditionalController::Children_And_Adult_Number_In_Room('children');
      }

      else{
        $room_value=AdditionalController::Children_And_Adult_Number_In_Room('adult');
      }
      // sending patient to room
      $data=new SendPatient();
      $data->patient_id=$id2;
      $data->registerar_id=$id1;
      $data->patient_room=$room_value;
      $save=$data->save();

      //update the updated_at 

      $update=AddPatient::find($id2);
      $update->updated_at=now();
      $save2=$update->save();

      if($save && $save2){
      	return redirect()->route('Home')->with('message_success','Sended to '.$room_value);
      }

      else{
      	 return redirect()->route('Home')->with('message_warning','Database Error');

      }


    }

}

app/Http/Controllers/Registerar/ProfileController.php
<?php

namespace App\Http\Controllers\Registerar;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
class ProfileController extends Controller
{
    public function ShowProfile(){
    	return view('Registerar/Profile');
    }
}

resources/views/Registerar/ChangePassword.blade.php
@extends('Registerar.Home')
@section('Sub_Content')
@parent
@component('ClinicLayout.PasswordTemplate',[
    'route'=>'Registerar.ChangePassword',
    'username'=>'id',
    'username_content'=>$id

	])
Change
@endcomponent
@endsection

resources/views/Registerar/ChangeProfile.blade.php
@extends('Registerar.Home')
@section('Sub_Content')
@parent
@component('ClinicLayout.Profile',[
	'id'=>'id',
	'content'=>$Data->username,
	'image_link'=>'Registerar.UpdateImage',
	'image_id'=>'image_id',
	'image_content'=>$Data->username,
	'route'=>'Registerar.UpdateProfile',
	'photo'=>$Data->photo,
	'full_name'=>$Data->full_name,
	'username'=>$Data->username,
	'graduated_status'=>$Data->graduated_status,
	'graduated_college_university'=>$Data->graduated_college_university,
	'email'=>$Data->email,
	'graduated_area'=>$Data->graduated_area,
	'passwordlink'=>"Registerar.Show_Password_Template",
	'password_id'=>'password_id',
	'password_content'=>$Data->username
	])
	<button type="submit" class="btn btn-outline-secondary">Save</button>

@endcomponent

@endsection

resources/views/Registerar/Home.blade.php
@extends('ClinicLayout.Main')
@section('tittle','Registerar')
@section('content')
<div class="container-fluid">
  
	@section('Sub_Content')
	<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <p class="navbar-brand nav-item m-auto">Astu Cms</p>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="nav-link" href="{{route('Home')}}">Home<span class="sr-only">(current)</span></a>
      </li>
      
    </ul>
    <button class="nav-tabs" id="Patient_Tab" style="margin-right: 20rem;">Add Patient</button>
    <form class="form-inline mr-auto" method="GET" action="{{route('Registerar.Search_Patient',['id'=>Auth::guard('Registerar')->user()->username])}}">
      <input class="form-control mr-sm-2" type="search" placeholder="Search" aria-label="Search" autofocus name="search">
      <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Search</button>
    </form>
    <div class="mr-5 dropdown">
    	<a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><span> {{Auth::guard('Registerar')->user()->username}}</span>
          <i class="fas fa-user"></i>
    	
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="{{route('Registerar.LogOut',['id'=>Auth::guard('Registerar')->user()->username])}}">LogOut</a>
          <a class="dropdown-item" href="{{route('Registerar.Profile',['id'=>Auth::guard('Registerar')->user()->username])}}">Profile</a>
    </div>
  </div>
</nav>

</div>
<div class="row" id="Patient_Submitter" style="display: none;">
  <div class="container">
    <div class="col-md-6">
    <div class="card">
      <div class="card-header">
        <p>Add Patient</p>
      </div>
        <div class="card-body">
          <form method="GET" action="{{route('Registerar.Add_Patient')}}">
            <div class="form-group">

              <label for="first_name">First Name</label>
              <input type="text" name="first_name" id="first_name" class="form-control" placeholder="first_name" autofocus="autofocus">

              <label for="last_name">Last Name</label>
              <input type="text" name="last_name" id="last_name" class="form-control" placeholder="last_name" autofocus>

              <label for="grand_name">Grand Name</label>
              <input type="text" name="grand_name" id="grand_name" class="form-control" placeholder="grand_name" autofocus>

              <label for="age">Age</label>
              <input type="text" name="age" id="age" class="form-control" placeholder="age" autofocus> 
              <label for="sex">Sex</label>
              <select class="form-control" id="sex" name="sex">
                <option>male</option>
                <option>female</option>
              </select>

              <button type="submit" class="btn btn-primary" style="margin-top:10px;float: right;">Add</button>
            </div>
          </form>
          
        </div>
    </div>
  </div> 
  </div>
</div>
@if($errors->any())
  @foreach($errors->all() as $error)
   <div class="alert-warning bg-danger" style="text-align: center;">
     {{$error}}
   </div>
  @endforeach
@endif

@if(Session::has('message_success'))
 <div class="alert bg-success" style="text-align: center;">{{Session::get('message_success')}}</div>
@endif

@if(Session::has('message_warning'))
 <div class="alert-warning bg-danger" style="text-align: center;">{{Session::get('message_warning')}}</div>
@endif

@if(!empty($Patient))
 @component('ClinicLayout.card',[
  'source'=>$Patient->photo_path,
  'name'=>$Patient->first_name,
  'lastname'=>$Patient->last_name,
  'age'=>$Patient->age,
  'sex'=>$Patient->sex,
  'clinicid'=>$Patient->clinic_id,
  'Send_To_Room'=>'Registerar.Send_Patient',
  'Link'=>'Send To Patient Room',
  'id1'=>'id1',
  'user_id'=>Auth::guard('Registerar')->user()->username,
  'id2'=>'id2',
  'patient_id'=>$Patient->clinic_id,
  
  ]);

 @endcomponent
@endif

<script type="text/javascript">
  jQuery(document).ready(function() {
    $("#Patient_Tab").click(function() {
      $("#Patient_Submitter").slideToggle("fast");
    });
    
  });
</script>

@show
@endsection

resources/views/Registerar/Profile.blade.php
@extends('Registerar.Home')
@section('Sub_Content')
@parent
<div class="container">
	<div class="row">
		<div class="col-md-8 col-sm-12">
			<div class="card">
				<div class="card-header text-center">
					Profile
				</div>
				<div class="card-body" style="height: auto;">
					<img src="{{asset('storage/'.Auth::guard('Registerar')->user()->photo)}}" class="rounded-circle card-img-top " style="width: 40%; height: 40%;" alt="user photo">

					<ul class="list-group list-unstyled">
						<li class="list-group-item"><b>Full Name</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->full_name}}</span></li>

						<li class="list-group-item"><b>E-mail</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->email}}</span></li>

						<li class="list-group-item"><b>Username</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->username}}</span></li>
						
						<li class="list-group-item"><b>Graduated_in</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->graduated_college_university}}</span></li>

						<li class="list-group-item"><b>Area of Studies</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->graduated_area}}</span></li>

						<li class="list-group-item"><b>sex</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->sex}}</span></li>

						<li class="list-group-item"><b>Age</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->age}}</span></li>

						<li class="list-group-item"><b>graduated_status</b><span class="badge" style="float: right;">{{Auth::guard('Registerar')->user()->graduated_status}}</span></li>
					</ul>
					<br>
					<a href="{{route('Registerar.ChangeProfile',['id'=>Auth::guard('Registerar')->user()->username])}}" class="btn btn-outline-success m-auto card-link">Edit</a>
				</div>	
			</div>
		</div>
	</div>
@endsection

resources/views/Registerar/UpdateImage.blade.php
@extends('Registerar.Home')
@section('Sub_Content')
@parent
<div class="container">
	<div class="row">
		<div class="col-md-4" style="margin-top: 10%;">
			<div class="form-group">
				<form method="post" action="{{route('Registerar.ImageUpdated',['id'=>$id])}}" enctype="multipart/form-data">
					@csrf
					<input type="file" name="photo" >
					<input type="submit" name="submit" value="update">
				</form>
			</div>
		</div>
	</div>
</div>
@endsection